zoukankan      html  css  js  c++  java
  • HDU 4614 Vases and Flowers(线段树+二分)

    Vases and Flowers

    Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others)
    Total Submission(s): 3220    Accepted Submission(s): 1273

    Problem Description
      Alice is so popular that she can receive many flowers everyday. She has N vases numbered from 0 to N-1. When she receive some flowers, she will try to put them in the vases, one flower in one vase. She randomly choose the vase A and try to put a flower in the vase. If the there is no flower in the vase, she will put a flower in it, otherwise she skip this vase. And then she will try put in the vase A+1, A+2, ..., N-1, until there is no flower left or she has tried the vase N-1. The left flowers will be discarded. Of course, sometimes she will clean the vases. Because there are too many vases, she randomly choose to clean the vases numbered from A to B(A <= B). The flowers in the cleaned vases will be discarded.
     
    Input
      The first line contains an integer T, indicating the number of test cases.
      For each test case, the first line contains two integers N(1 < N < 50001) and M(1 < M < 50001). N is the number of vases, and M is the operations of Alice. Each of the next M lines contains three integers. The first integer of one line is K(1 or 2). If K is 1, then two integers A and F follow. It means Alice receive F flowers and try to put a flower in the vase A first. If K is 2, then two integers A and B follow. It means the owner would like to clean the vases numbered from A to B(A <= B).
     
    Output
      For each operation of which K is 1, output the position of the vase in which Alice put the first flower and last one, separated by a blank. If she can not put any one, then output 'Can not put any one.'. For each operation of which K is 2, output the number of discarded flowers. 
      Output one blank line after each test case.
     
    Sample Input
    2
    10 5
    1 3 5
    2 4 5
    1 1 8
    2 3 6
    1 8 8
     
    10 6
    1 2 5
    2 3 4
    1 0 8
    2 2 5
    1 4 4
    1 2 3
     
    Sample Output
    3 7
    2
    1 9
    4
    Can not put any one.
     
    2 6
    2
    0 9
    4
    4 5
    2 3

    题目链接:HDU 4614

    题意就是给一个编号为0~N-1的花瓶,给一系列操作:1、从起始点S开始插入F朵花,插入时连续地从左到右扫描过去若花瓶有空且花没用完就一定要插到花瓶里,最后要么花用完了要么没位置可以放置了;2、清空编号从L到R花瓶。

    这题第二问明显可以用线段树做,而且由于前缀和的缘故,花的前缀和数量在编号序列上具有单调性,因此第一问可以用二分做,但是二分开头简单,二分结尾就比较恶心,调试了很久,仔细考虑可以发现会有这样一个容易错误的地方:若从头到尾空位比花少,则终点为第一个达到最大空位的位置,而不是一直到结尾,因此要仅当当前位置的前缀空位和等于最大空位数的时候才记录终点T。如果二分结尾不正确估计第二组样例会对不上

    代码:

    #include <stdio.h>
    #include <bits/stdc++.h>
    using namespace std;
    #define INF 0x3f3f3f3f
    #define LC(x) (x<<1)
    #define RC(x) ((x<<1)+1)
    #define MID(x,y) ((x+y)>>1)
    #define CLR(arr,val) memset(arr,val,sizeof(arr))
    #define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
    typedef pair<int, int> pii;
    typedef long long LL;
    const double PI = acos(-1.0);
    const int N = 50010;
    struct seg
    {
        int l, mid, r;
        int sum, add;
        inline int len()
        {
            return r - l + 1;
        }
    };
    seg T[N << 2];
    
    inline void pushup(int k)
    {
        T[k].sum = T[LC(k)].sum + T[RC(k)].sum;
    }
    inline void pushdown(int k)
    {
        if (!T[k].add)
            return ;
        T[LC(k)].add = T[k].add;
        T[RC(k)].add = T[k].add;
        T[LC(k)].sum = (T[k].add == 1) * T[LC(k)].len();
        T[RC(k)].sum = (T[k].add == 1) * T[RC(k)].len();
        T[k].add = 0;
    }
    void build(int k, int l, int r)
    {
        T[k].l = l;
        T[k].r = r;
        T[k].mid = MID(l, r);
        T[k].sum = T[k].add = 0;
        if (l == r)
            return ;
        else
        {
            build(LC(k), l, T[k].mid);
            build(RC(k), T[k].mid + 1, r);
        }
    }
    void update(int k, int l, int r, int flag)
    {
        if (l <= T[k].l && T[k].r <= r)
        {
            T[k].add = flag;
            T[k].sum = (flag == 1 ? T[k].len() : 0);
        }
        else
        {
            pushdown(k);
            if (l <= T[k].mid)
                update(LC(k), l, r, flag);
            if (r > T[k].mid)
                update(RC(k), l, r, flag);
            pushup(k);
        }
    }
    int query(int k, int l, int r)
    {
        if (l <= T[k].l && T[k].r <= r)
            return T[k].sum;
        else
        {
            pushdown(k);
            if (r <= T[k].mid)
                return query(LC(k), l, r);
            else if (l > T[k].mid)
                return query(RC(k), l, r);
            else
                return query(LC(k), l, T[k].mid) + query(RC(k), T[k].mid + 1, r);
        }
    }
    int main(void)
    {
        int tcase, n, m, ops, l, r;
        scanf("%d", &tcase);
        while (tcase--)
        {
            scanf("%d%d", &n, &m);
            build(1, 0, n - 1);
            while (m--)
            {
                scanf("%d%d%d", &ops, &l, &r);
                if (ops == 2)
                {
                    int discard = query(1, l, r);
                    update(1, l, r, -1);
                    printf("%d
    ", discard);
                }
                else if (ops == 1)
                {
                    int S = -1; //二分找到第一个为空的点
                    int L = l, need = r, R = n - 1;
                    while (L <= R)
                    {
                        int mid = (L + R) >> 1;
                        if (query(1, l, mid) < mid - l + 1)
                        {
                            S = mid;
                            R = mid - 1;
                        }
                        else
                            L = mid + 1;
                    }
                    if (S == -1)//连开头位置都不存在,肯定位置全满了
                        puts("Can not put any one.");
                    else
                    {
                        int maxmvacnt = (n - 1 - S + 1) - query(1, S, n - 1);//用实际上最大的空位数而不是花朵数去二分
                        need = min<int>(need, maxmvacnt);
                        int T = -1;
                        int L = S, R = n - 1;
                        while (L <= R)
                        {
                            int mid = (L + R) >> 1;
                            int vacant = mid - S + 1 - query(1, S, mid);
                            if (vacant < need)
                                L = mid + 1;
                            else if (vacant == need) //此处与普通二分有一点不同
                            {
                                T = mid;
                                R = mid - 1;
                            }
                            else
                                R = mid - 1;
                        }
                        printf("%d %d
    ", S, T);
                        update(1, S, T, 1);
                    }
                }
            }
            putchar('
    ');
        }
        return 0;
    }
  • 相关阅读:
    项目源码--Android即时通讯IM客户端
    项目源码--Android美图秀秀源码
    实例源码--IOS高仿微信打飞机游戏(完整功能)
    项目源码--IOS自定义视频播放器
    精品教程--IOS零基础开发环境搭建
    项目源码--Android答题类游戏源码
    项目源码--Android类似酷狗音乐播放器
    项目源码--JSP在线客服系统(SSH框架技术)源码
    项目源码--JAVA基于LBS地理位置信息应用的服务端
    项目源码--Android视频MV类网站客户端
  • 原文地址:https://www.cnblogs.com/Blackops/p/6292922.html
Copyright © 2011-2022 走看看